/* for log file output
 * 2003.01.29-
 * Time-stamp: <2003-10-04 14:47:08 dimm>
 */
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <gtk/gtk.h>

#include "seemon2.h"

int setoutputfile (void) {
  char outstr[256];

  /* update ctime */
  get_localtime(&(mseemon.ctime));

//  sprintf(outstr, "%s/seemon%04d%02d%02d%02d%02d%02d.log", 
// changed by T.Hattori, 2004/07/14
  sprintf(outstr, "%s/seemon%04d%02d%02d.log", 
	  LOGPATH,
	  mseemon.ctime.year, 
	  mseemon.ctime.month,
	  mseemon.ctime.day);
//	  mseemon.ctime.hour,
//	  mseemon.ctime.min,
//	  mseemon.ctime.sec);

  printf("output file: %s\n", outstr);

  if ((fout = fopen(outstr, "a")) == NULL) {
    printf("failed in opening logfile %s.\n");
    return(EXIT_FAILURE);
  }

  fprintf(fout, "#logfile of seemon2 version %s\n", VERSION);
  fprintf(fout, "#date-time          cg0x   cg0y   cg1x   cg1y   diffcgx     diffcgy      r0x      r0y      fwhmx  fwhmy fwhmcx fwhmcy ndata  telra  teldc telha telel\n");

  return(EXIT_SUCCESS);
}

/* close log file */
void closeoutputfile(void) {
  fclose(fout);
}
