#!/usr/bin/perl -w
# 2004.11.24
# 2004.12.01
# 2004.12.06 iwata

use CGI qw(:standard);

# files and paths
$loglistpath="/net/dimm/dimm1/log/loglist.txt";
$logpath = "/usr/local/apache/htdocs/dimm/dimm1/log/";
$logurl  = "http://www.oao.nao.ac.jp/dimm/dimm1/log/";
#$imgpath = "/usr/local/apache/htdocs/dimm/dimm1/img/";
$imgurl  = "http://www.oao.nao.ac.jp/dimm/dimm1/img/";
$cgiurl  = "http://www.oao.nao.ac.jp/cgi-bin/";
$cgifile = "dimm1.cgi";
$altcgi = "http://www.oao.nao.ac.jp/cgi-bin/dimmstat1.cgi";

print header;
print "<meta http-equiv=\"Refresh\" content=\"300\">";

print start_html("DIMM results");

$yn = 0;

$maxdate = 20020101;
$n = 0;
open(IN, $loglistpath);
while (<IN>) {
    chomp();
    $filename = $_;
    $loglist[$n] = $filename;
    $n++;

    if ($filename =~ /.log/) {
	$date = $filename;
	$date =~ s/seemon//;
	$date =~ s/.log//;
	if ($date > $maxdate) {
	    $maxdate = $date;
	    $logfile = $filename;
	}
	# year list
	$year = substr($date, 0, 4);
	$flg = 0;
	for ($i = 0; $i < $yn; $i++) {
	    if ($ystr[$i] == $year) {
		$flg = 1;
	    }
	}
	if ($flg == 0) {
	    $ystr[$yn] = $year;
	    $yn++;
	}

	# month list
	$mon = substr($date, 4, 2);
	for ($i = 1; $i < 13; $i++) {
	    if ($i == $mon) {
		$mflg[$i] = 1;
	    }
	}

	# day list
	$day = substr($date, 6, 2);
	for ($i = 0; $i < 32; $i++) {
	    if ($i == $day) {
		$dflg[$i] = 1;
	    }
	}
    }
}
close(IN);

$logpath = $logpath.$logfile;
open(IN, $logpath); 
while (<IN>) {
    if ($_ !~ /^\#/) {
	@fld = split;
	$lastupdate = $fld[0];
    }
}
close(IN);

if (!param()) {
    print "last update: $lastupdate\n";
    $str = "<a href=\"".$logurl.$logfile."\">log text file</a>\n";
    print $str;

    print hr();

    $fwhmfile = $logfile;
    $fwhmfile =~ s/.log/_fwhm.png/;
    $fwhmfile = $imgurl.$fwhmfile;

    $peakfile = $logfile;
    $peakfile =~ s/.log/_peak.png/;
    $peakfile = $imgurl.$peakfile;

    print "<img src=\"$fwhmfile\">\n";

    print "<img src=\"$peakfile\">\n";
    $year = -1;
    $month = -1;
    $day = -1;
} else {
    $year = param("year");
    $month = param("month");
    $day = param("date");
    
    $logfile = "seemon".$year.$month.$day.".log";
    # check file exists
    $flg = 0;
    for ($i = 0; $i < $n; $i++) {
	if ($logfile eq $loglist[$i]) {
	    $flg = 1;
	}
    }

    if ($flg) {
	$fwhmfile = $logfile;
	$fwhmfile =~ s/.log/_fwhm.png/;
	$fwhmfile = $imgurl.$fwhmfile;

	$peakfile = $logfile;
	$peakfile =~ s/.log/_peak.png/;
	$peakfile = $imgurl.$peakfile;

	$str = "<a href=\"".$logurl.$logfile."\">log text file</a>";
	print $str;

	print "<img src=\"$fwhmfile\">\n";

	print "<img src=\"$peakfile\">\n";

	print "<p>";
	print "FWHM (arcsec): ";
	print "Blue=transverse, Red=longitudinal";
	print "</p>";
	print "<p>";
	print "Peak(count) / Altitude(deg) / Shutter Speed(100usec): ";
	print "Blue,Red=peaks, ";
	print "Green=altitude, Orange=Shutter";
	print "</p>";
    } else {
	print "<h2>$logfile: file does not exist.</h2>";
    }
}

print hr();

### FORM
print "<form method=\"post\" action=\"/cgi-bin/$cgifile\" enctype=\"application/x-www-form-urlencoded\">";
print "<p>year <select name=\"year\">";
for ($i = 0; $i < $yn; $i++) {
    if ($ystr[$i] == $year) {
	printf " <option selected=\"selected\" value=\"%s\">%s</option>\n", $ystr[$i], $ystr[$i];
    } else {
	printf " <option value=\"%s\">%s</option>\n", $ystr[$i], $ystr[$i];
    }
}
print "</select>";
print "/ month <select name=\"month\">";
for ($i = 0; $i < 13; $i++) {
    if ($mflg[$i]) {
	if ($month == $i) {
	    printf " <option selected=\"selected\" value=\"%02d\">%02d</option>\n", $i, $i;
	} else {
	    printf " <option value=\"%02d\">%02d</option>\n", $i, $i;
	}
    }
}
print "</select>";
print "/ day <select name=\"date\">";
for ($i = 0; $i < 32; $i++) {
    if ($dflg[$i]) {
	if ($day == $i) {
	    printf " <option selected=\"selected\" value=\"%02d\">%02d</option>\n", $i, $i;
	} else {
	    printf " <option value=\"%02d\">%02d</option>\n", $i, $i;
	}
    }
}
print "</select>";
print "<input type=\"submit\" name=\"display\" value=\"display\" /></p>";
print "</form>";

print "<a href=\"".$cgipath.$cgifile."\">Latest</a><br />";
print "<a href=\"".$altcgi."\">Statistics</a>";
print hr();

print end_html;

